<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ExceptionTranslator.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.web.rest.errors</a> &gt; <span class="el_source">ExceptionTranslator.java</span></div><h1>ExceptionTranslator.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.web.rest.errors;

import java.util.List;

import org.springframework.core.annotation.AnnotationUtils;
import org.springframework.dao.ConcurrencyFailureException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.http.ResponseEntity.BodyBuilder;
import org.springframework.security.access.AccessDeniedException;
import org.springframework.validation.BindingResult;
import org.springframework.validation.FieldError;
import org.springframework.web.HttpRequestMethodNotSupportedException;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.*;

/**
 * Controller advice to translate the server side exceptions to client-friendly json structures.
 */
@ControllerAdvice
<span class="fc" id="L21">public class ExceptionTranslator {</span>

    @ExceptionHandler(ConcurrencyFailureException.class)
    @ResponseStatus(HttpStatus.CONFLICT)
    @ResponseBody
    public ErrorVM processConcurrencyError(ConcurrencyFailureException ex) {
<span class="nc" id="L27">        return new ErrorVM(ErrorConstants.ERR_CONCURRENCY_FAILURE);</span>
    }

    @ExceptionHandler(MethodArgumentNotValidException.class)
    @ResponseStatus(HttpStatus.BAD_REQUEST)
    @ResponseBody
    public ErrorVM processValidationError(MethodArgumentNotValidException ex) {
<span class="fc" id="L34">        BindingResult result = ex.getBindingResult();</span>
<span class="fc" id="L35">        List&lt;FieldError&gt; fieldErrors = result.getFieldErrors();</span>
<span class="fc" id="L36">        ErrorVM dto = new ErrorVM(ErrorConstants.ERR_VALIDATION);</span>
<span class="fc bfc" id="L37" title="All 2 branches covered.">        for (FieldError fieldError : fieldErrors) {</span>
<span class="fc" id="L38">            dto.add(fieldError.getObjectName(), fieldError.getField(), fieldError.getCode());</span>
<span class="fc" id="L39">        }</span>
<span class="fc" id="L40">        return dto;</span>
    }

    @ExceptionHandler(CustomParameterizedException.class)
    @ResponseStatus(HttpStatus.BAD_REQUEST)
    @ResponseBody
    public ParameterizedErrorVM processParameterizedValidationError(CustomParameterizedException ex) {
<span class="nc" id="L47">        return ex.getErrorVM();</span>
    }

    @ExceptionHandler(AccessDeniedException.class)
    @ResponseStatus(HttpStatus.FORBIDDEN)
    @ResponseBody
    public ErrorVM processAccessDeniedException(AccessDeniedException e) {
<span class="nc" id="L54">        return new ErrorVM(ErrorConstants.ERR_ACCESS_DENIED, e.getMessage());</span>
    }

    @ExceptionHandler(HttpRequestMethodNotSupportedException.class)
    @ResponseBody
    @ResponseStatus(HttpStatus.METHOD_NOT_ALLOWED)
    public ErrorVM processMethodNotSupportedException(HttpRequestMethodNotSupportedException exception) {
<span class="nc" id="L61">        return new ErrorVM(ErrorConstants.ERR_METHOD_NOT_SUPPORTED, exception.getMessage());</span>
    }

    @ExceptionHandler(Exception.class)
    public ResponseEntity&lt;ErrorVM&gt; processRuntimeException(Exception ex) {
        BodyBuilder builder;
        ErrorVM errorVM;
<span class="nc" id="L68">        ResponseStatus responseStatus = AnnotationUtils.findAnnotation(ex.getClass(), ResponseStatus.class);</span>
<span class="nc bnc" id="L69" title="All 2 branches missed.">        if (responseStatus != null) {</span>
<span class="nc" id="L70">            builder = ResponseEntity.status(responseStatus.value());</span>
<span class="nc" id="L71">            errorVM = new ErrorVM(&quot;error.&quot; + responseStatus.value().value(), responseStatus.reason());</span>
        } else {
<span class="nc" id="L73">            builder = ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR);</span>
<span class="nc" id="L74">            errorVM = new ErrorVM(ErrorConstants.ERR_INTERNAL_SERVER_ERROR, &quot;Internal server error&quot;);</span>
        }
<span class="nc" id="L76">        return builder.body(errorVM);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>